#include <iostream>
#include <string>
#include "TriangleColumns.h"



std::string Tri::getColumnStr(Tri::Col colEnum){

	std::string retStr = "";

	switch(colEnum)
	{
		case Tri::L1     :	retStr="L1"			;break;
		case Tri::L2     :	retStr="L2"			;break;
		case Tri::L2_G1  :	retStr="L2_G1"		;break;
		case Tri::L2_G2  :	retStr="L2_G2"		;break;
		case Tri::L2_G3  :	retStr="L2_G3"		;break;
		case Tri::L2_G4  :	retStr="L2_G4"		;break;
		case Tri::L3     :	retStr="L3"			;break;
		case Tri::L3_G01 :	retStr="L3_G01"		;break;
		case Tri::L3_G02 :	retStr="L3_G02"		;break;
		case Tri::L3_G03 :	retStr="L3_G03"		;break;
		case Tri::L3_G1  :	retStr="L3_G1"		;break;
		case Tri::L3_G11 :	retStr="L3_G11"		;break;
		case Tri::L3_G12 :	retStr="L3_G12"		;break;
		case Tri::L3_G2  :	retStr="L3_G2"		;break;
		case Tri::L3_G21 :	retStr="L3_G21"		;break;
		case Tri::L3_G3  :	retStr="L3_G3"		;break;
		case Tri::L4     :	retStr="L4"			;break;
		case Tri::L4_G01 :	retStr="L4_G01"		;break;
		case Tri::L4_G02 :	retStr="L4_G02"		;break;
		case Tri::L4_G1  :	retStr="L4_G1"		;break;
		case Tri::L4_G101:	retStr="L4_G101"	;break;
		case Tri::L4_G11 :	retStr="L4_G11"		;break;
		case Tri::L4_G2  :	retStr="L4_G2"		;break;
		case Tri::L5     :	retStr="L5"			;break;
		case Tri::L5_G01 :	retStr="L5_G01"		;break;
		case Tri::L5_G1  :	retStr="L5_G1"		;break;
		case Tri::L6     :	retStr="L6"			;break;
		default : throw "Illegal column name in function Tri::getColumnStr";
	}

	return retStr;
}

Tri::Col Tri::getEnum(std::string columnName)
{
	if(columnName ==		"L1"		){	return Tri::L1		;}
	else if(columnName ==	"L2"		){	return Tri::L2		;}
	else if(columnName ==	"L2_G1"		){	return Tri::L2_G1	;}
	else if(columnName ==	"L2_G2"		){	return Tri::L2_G2	;}
	else if(columnName ==	"L2_G3"		){	return Tri::L2_G3	;}
	else if(columnName ==	"L2_G4"		){	return Tri::L2_G4	;}
	else if(columnName ==	"L3"		){	return Tri::L3		;}
	else if(columnName ==	"L3_G01"	){	return Tri::L3_G01	;}
	else if(columnName ==	"L3_G02"	){	return Tri::L3_G02	;}
	else if(columnName ==	"L3_G03"	){	return Tri::L3_G03	;}
	else if(columnName ==	"L3_G1"		){	return Tri::L3_G1	;}
	else if(columnName ==	"L3_G11"	){	return Tri::L3_G11	;}
	else if(columnName ==	"L3_G12"	){	return Tri::L3_G12	;}
	else if(columnName ==	"L3_G2"		){	return Tri::L3_G2	;}
	else if(columnName ==	"L3_G21"	){	return Tri::L3_G21	;}
	else if(columnName ==	"L3_G3"		){	return Tri::L3_G3	;}
	else if(columnName ==	"L4"		){	return Tri::L4		;}
	else if(columnName ==	"L4_G01"	){	return Tri::L4_G01	;}
	else if(columnName ==	"L4_G02"	){	return Tri::L4_G02	;}
	else if(columnName ==	"L4_G1"		){	return Tri::L4_G1	;}
	else if(columnName ==	"L4_G101"	){	return Tri::L4_G101	;}
	else if(columnName ==	"L4_G11"	){	return Tri::L4_G11	;}
	else if(columnName ==	"L4_G2"		){	return Tri::L4_G2	;}
	else if(columnName ==	"L5"		){	return Tri::L5		;}
	else if(columnName ==	"L5_G01"	){	return Tri::L5_G01	;}
	else if(columnName ==	"L5_G1"		){	return Tri::L5_G1	;}
	else if(columnName ==	"L6"		){	return Tri::L6		;}
	else { throw "Illegal Column Name in method Tri::getEnumVal";}

}

// This number must be Zero-based.
Tri::Col Tri::getEnum(int itterate)
{
	if(itterate >= Tri::pyramidDepth || itterate < 0){
		throw "Illegal value in method Tri::getEnum()";
	}

	// Cast the integer into our "Enum Type" (now that we are sure it is in range).
	Tri::Col returnEnum = (Tri::Col)itterate;

	return returnEnum;
}